<?php
/*
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2013 osCommerce

  Released under the GNU General Public License
*/

require(DIR_FS_CATALOG . 'ext/piwik/configure.php');

function piwik_ecommerce() {
  global $PHP_SELF, $HTTP_GET_VARS, $languages_id, $customer_id, $current_category_id, $cart;
  $output = '';

  switch (basename($PHP_SELF)) {
    case FILENAME_DEFAULT:
      $categories_name = '';
      if($current_category_id > 0) {
        $categories_name = piwik_categories_name($current_category_id);
        if ($categories_name != '') {
          $output .= '_paq.push(["setEcommerceView",productSku = false,productName = false,category = "' . tep_output_string($categories_name) . '"]);' . "\n";
        }         
      }
      break;
    case FILENAME_PRODUCT_INFO:
      if($HTTP_GET_VARS['products_id'] != '') {
        $categories_name = '';
        $products_query = tep_db_query("select p.products_model, pd.products_name from " . TABLE_PRODUCTS . " p, " . TABLE_PRODUCTS_DESCRIPTION . " pd where p.products_status = '1' and p.products_id = pd.products_id and pd.language_id = '" . (int)$languages_id . "' and p.products_id = '" . (int)$HTTP_GET_VARS['products_id'] . "'");
        $products = tep_db_fetch_array($products_query);  
        if($current_category_id > 0) {
          $categories_name = piwik_categories_name($current_category_id);        
        }     
        if ($products['products_name'] != '') {
          $output .= '_paq.push(["setEcommerceView",productSku = "' . tep_output_string($products['products_model']) . '",productName = "' . tep_output_string($products['products_name']) . '",category = "' . tep_output_string($categories_name) . '"]);' . "\n";
        }         
      }
      break;   
    case FILENAME_SHOPPING_CART:
      $products = $cart->get_products();
      if ($cart->count_contents() > 0) {
        for ($i=0, $n=sizeof($products); $i<$n; $i++) { 
          $categories_name = piwik_product_categories_name($products[$i]['id']);
          $output .= '_paq.push(["addEcommerceItem","' . tep_output_string($products[$i]['model']) . '","' . tep_output_string($products[$i]['name']) . '","'. tep_output_string($categories_name) . '",' . piwik_format_raw($products[$i]['final_price']) . ', ' . (int)$products[$i]['quantity'] . ']);' . "\n"; 
 
        }
        $output .= '_paq.push(["trackEcommerceCartUpdate",' . piwik_format_raw($cart->show_total()) . ']);' . "\n";
      }
      break; 
    case FILENAME_CHECKOUT_SUCCESS:
      if(tep_session_is_registered('customer_id')) {
          $order_query = tep_db_query("select orders_id from " . TABLE_ORDERS . " where customers_id = '" . (int)$customer_id . "' order by date_purchased desc limit 1");

          if (tep_db_num_rows($order_query) == 1) {
            $order = tep_db_fetch_array($order_query);

            $totals = array();

            $order_totals_query = tep_db_query("select value, class from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . (int)$order['orders_id'] . "'");
            while ($order_totals = tep_db_fetch_array($order_totals_query)) {
              $totals[$order_totals['class']] = $order_totals['value'];
            }

            $order_products_query = tep_db_query("select products_id, products_model, products_name, final_price, products_quantity from " . TABLE_ORDERS_PRODUCTS . " where orders_id = '" . (int)$order['orders_id'] . "'");
            while ($order_products = tep_db_fetch_array($order_products_query)) {
              $categories_name = piwik_product_categories_name($order_products['products_id']);
              $output .= '_paq.push(["addEcommerceItem","' . tep_output_string($order_products['products_model']) . '","' . tep_output_string($order_products['products_name']) . '","' . tep_output_string($categories_name) . '",' . piwik_format_raw($order_products['final_price']) . ',' . (int)$order_products['products_quantity'] . ']);' . "\n";            
            }
             
            $output .= '_paq.push(["trackEcommerceOrder","' . (int)$order['orders_id'] . '",' . (isset($totals['ot_total']) ? piwik_format_raw($totals['ot_total']) : 0) . ',' . (isset($totals['ot_subtotal']) ? piwik_format_raw($totals['ot_subtotal']) : 0) . ','.(isset($totals['ot_tax']) ? piwik_format_raw($totals['ot_tax']) : 0) . ',' . (isset($totals['ot_shipping']) ? piwik_format_raw($totals['ot_shipping']) : 0) . ',false]);' . "\n";                    

          }       
      }
      break;
  }

  return $output;

}

function piwik_categories_name($category_id) {
  global $languages_id;    

  $categories_query = tep_db_query("select categories_name from " . TABLE_CATEGORIES_DESCRIPTION . " where categories_id = '" . (int)$category_id . "' and language_id = '" . (int)$languages_id . "'");
  $categories = tep_db_fetch_array($categories_query); 

  return $categories['categories_name'];
}

function piwik_product_categories_name($products_id) {
  global $languages_id;  

  $categories_query = tep_db_query("select cd.categories_name from " . TABLE_CATEGORIES_DESCRIPTION . " cd, " . TABLE_PRODUCTS_TO_CATEGORIES . " p2c where p2c.products_id = '" . (int)$products_id . "' and p2c.categories_id = cd.categories_id and cd.language_id ='".(int)$languages_id."' limit 1");   
  $categories = tep_db_fetch_array($categories_query); 

  return $categories['categories_name'];    
}

function piwik_format_raw($number) {      
  return number_format($number, 2, '.', '');
}
?>

<!-- Piwik -->
<script type="text/javascript">
var _paq = _paq || [];
<?php 
if(PIWIK_TRACKING_ALL_SUBDOMAINS == true) { 
  echo '_paq.push(["setCookieDomain", "*.' . SHOP_DOMAIN . '"]);' . "\n";
}
if(PIWIK_TRACKING_GROUP_BY_DOMAIN == true) { 
  echo '_paq.push(["setDocumentTitle", document.domain + "/" + document.title]);' . "\n";
}
if(PIWIK_TRACKING_ALL_ALIASES == true) { 
  echo '_paq.push(["setDomains", ["*.' . SHOP_DOMAIN . '"]]);' . "\n";
}
if(PIWIK_TRACKING_DO_NOT_TRACK == true) { 
  echo '_paq.push(["setDoNotTrack", true]);' . "\n";
}
if(PIWIK_ECOMMERCE == true) { 
  echo piwik_ecommerce();
}
?>
_paq.push(["trackPageView"]);
_paq.push(["enableLinkTracking"]);
(function() {
  var u=(("https:" == document.location.protocol) ? "https" : "http") + "://<?php echo PIWIK_PATH; ?>";
  _paq.push(["setTrackerUrl", u+"piwik.php"]);
  _paq.push(["setSiteId", "<?php echo PIWIK_SITE_ID; ?>"]);
  var d=document, g=d.createElement("script"), s=d.getElementsByTagName("script")[0]; g.type="text/javascript";
  g.defer=true; g.async=true; g.src=u+"piwik.js"; s.parentNode.insertBefore(g,s);
})();
</script>
<noscript><p><img src="http://<?php echo PIWIK_PATH; ?>piwik.php?idsite=<?php echo PIWIK_SITE_ID; ?>" style="border:0;" alt="" /></p></noscript>
<!-- End Piwik Code -->

